﻿local RSwapper3 = LibStub("AceAddon-3.0"):GetAddon("RSwapper3");
local L = LibStub("AceLocale-3.0"):GetLocale("RSwapper3", true);

local RS3GUI = RSwapper3.RS3GUI;

local TabFrame = RS3GUI.TabFrame;
local WeaponFrame = RS3GUI.SubFrame[1];
local OptionsFrame = RS3GUI.SubFrame[2];

function OptionsFrame:DoInit()
	OptionsFrame.DidInit = true;
	
	OptionsFrame:SetFrameStrata("DIALOG");
	OptionsFrame:SetWidth(RS3GUI.Width);
	OptionsFrame:SetBackdrop({
			bgFile="Interface\\DialogFrame\\UI-DialogBox-Background",
			edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
			tile = true, tileSize = 32, edgeSize = 32, 
			insets = { left = 8, right = 8, top = 8, bottom = 8 }
		});
	OptionsFrame:SetBackdropColor(0,0,0,1);
	OptionsFrame:EnableMouse();
	OptionsFrame:SetPoint("TOPLEFT", TabFrame, "BOTTOMLEFT", 0, 12);
	
	OptionsFrame.CheckList = {};
	OptionsFrame.CheckList.Height = 0;
	
	OptionsFrame:AddCheck(OptionsFrame.CheckList, ENABLE_SOUNDFX, RSwapper3.SetSound, "Sound");
	OptionsFrame:AddCheck(OptionsFrame.CheckList, L[" Toggle looking for weapons in Off-Hand slot."], RSwapper3.SetOffhand, "Offhand");
	OptionsFrame:AddCheck(OptionsFrame.CheckList, L[" Toggle swapping when your target is stunned."], RSwapper3.SetStealth, function() return (not RSwapper3.db.char.Stealth) end);
	OptionsFrame:AddCheck(OptionsFrame.CheckList, L[" Toggle swapping during Shadow Dance buff."], RSwapper3.SetDance, "Dance");
	OptionsFrame:AddCheck(OptionsFrame.CheckList, L[" Toggle announcing when you cast Blind via Say."], RSwapper3.SetBlind, "Blind");
	
	OptionsFrame:SetHeight(OptionsFrame.CheckList.Height + 26);
end

function OptionsFrame:AddCheck(list, label, func, value)
	local index = (#list) + 1;
	
	local CheckLine = {};
	CheckLine.Value = value;
	
	CheckLine.Box = CreateFrame("CheckButton", nil, OptionsFrame, "UICheckButtonTemplate");
	CheckLine.Label = OptionsFrame:CreateFontString("$parent_CheckLabel" .. index,"ARTWORK","GameFontNormal");
	
	if (index == 1) then
		CheckLine.Box:SetPoint("TOPLEFT", OptionsFrame, "TOPLEFT", 13, -13);
	else
		CheckLine.Box:SetPoint("TOPRIGHT", list[index-1].Label, "BOTTOMLEFT", 0, 0);
	end
	CheckLine.Box:SetScript("OnClick", function(self, button)
			if (button == "LeftButton") then
				func();
			end
		end);
		
	CheckLine.Label:SetPoint("TOPLEFT", CheckLine.Box, "TOPRIGHT");
	CheckLine.Label:SetWidth(RS3GUI.Width - 26 - CheckLine.Box:GetWidth());
	CheckLine.Label:SetText(label);
	CheckLine.Label:SetJustifyH("LEFT");
	CheckLine.Label:SetJustifyV("MIDDLE");
	if (CheckLine.Label:GetHeight() < CheckLine.Box:GetHeight()) then
		CheckLine.Label:SetHeight(CheckLine.Box:GetHeight());
	end
	list.Height = list.Height + CheckLine.Label:GetHeight();
	
	list[index] = CheckLine;	
end

function OptionsFrame:DoUpdate()
	for i, CheckLine in ipairs(OptionsFrame.CheckList) do
		if (type(CheckLine.Value) == "function") then
			CheckLine.Box:SetChecked(CheckLine.Value());
		else
			CheckLine.Box:SetChecked(RSwapper3.db.char[CheckLine.Value]);
		end
	end
end